diff --git a/drupal7/sites/all/modules/ctools/plugins/access/entity_field_value.inc b/drupal7/sites/all/modules/ctools/plugins/access/entity_field_value.inc
index ab36ca9a..fa94a481 100644
--- a/drupal7/sites/all/modules/ctools/plugins/access/entity_field_value.inc
+++ b/drupal7/sites/all/modules/ctools/plugins/access/entity_field_value.inc
@@ -16,8 +16,8 @@ $plugin = array(
   'get child' => 'ctools_entity_field_value_ctools_access_get_child',
   'get children' => 'ctools_entity_field_value_ctools_access_get_children',
 );
-function ctools_entity_field_value_ctools_access_get_child($plugin, $parent, $child) {
 
+function ctools_entity_field_value_ctools_access_get_child($plugin, $parent, $child) {
   $plugins = &drupal_static(__FUNCTION__, array());
   if (empty($plugins[$parent . ':' . $child])) {
     list($entity_type, $bundle_type, $field_name) = explode(':', $child);
@@ -48,7 +48,6 @@ function ctools_entity_field_value_ctools_access_get_children($plugin, $parent)
 }
 
 function _ctools_entity_field_value_ctools_access_get_child($plugin, $parent, $entity_type, $bundle_type, $field_name, $entity = NULL, $bundle = NULL, $field = NULL) {
-
   // check that the entity, bundle and field arrays have a value.
   // If not, load theme using machine names.
   if (empty($entity)) {
@@ -86,12 +85,34 @@ function ctools_entity_field_value_ctools_access_settings($form, &$form_state, $
   $instance    = $instances[$field_name];
   $field       = field_info_field_by_id($instance['field_id']);
   foreach ($field['columns'] as $column => $attributes) {
-    $columns[] = _field_sql_storage_columnname($field_name, $column);
+    $columns[$column] = _field_sql_storage_columnname($field_name, $column);
   }
   ctools_include('fields');
   $entity = (object)array(
     $entity_info['entity keys']['bundle'] => $bundle_type,
   );
+
+  foreach ($columns as $column => $sql_column) {
+    if (isset($conf[$sql_column])) {
+      if (is_array($conf[$sql_column])) {
+        foreach ($conf[$sql_column] as $delta => $conf_value) {
+          if (is_numeric($delta)) {
+            if (is_array($conf_value)) {
+              $entity->{$field_name}[LANGUAGE_NONE][$delta][$column] = $conf_value[$column];
+            }
+            else {
+              $entity->{$field_name}[LANGUAGE_NONE][$delta][$column] = $conf_value;
+            }
+          }
+        }
+      }
+      else {
+        $entity->{$field_name}[LANGUAGE_NONE][0][$column] = $conf[$sql_column];
+      }
+    }
+  }
+
+  $form['#parents'] = array('settings');
   $langcode = field_valid_language(NULL);
   $form['settings'] += (array) ctools_field_invoke_field($instance, 'form', $entity_type, $entity, $form, $form_state, array('default' => TRUE, 'language' => $langcode));
   // weight is really not important once this is populated and will only interfere with the form layout.
@@ -99,26 +120,9 @@ function ctools_entity_field_value_ctools_access_settings($form, &$form_state, $
     unset($form['settings'][$element]['#weight']);
   }
 
-  // Need more logic here to handle compound fields.
-  foreach ($columns as $column) {
-    if (isset($conf[$column]) && is_array($conf[$column])) {
-      foreach ($conf[$column] as $delta => $conf_value) {
-        if (is_numeric($delta) && is_array($conf_value)) {
-          $form['settings'][$field_name][LANGUAGE_NONE][$delta]['value']['#default_value'] = $conf_value['value'];
-        }
-      }
-    }
-    else {
-      $form['settings'][$field_name][LANGUAGE_NONE]['#default_value'] = $conf[$column];
-    }
-  }
-
   return $form;
 }
 
-/**
- * Compress the entity bundles allowed to the minimum.
- */
 function ctools_entity_field_value_ctools_access_settings_submit($form, &$form_state) {
   $plugin = $form_state['plugin'];
   list($parent, $entity_type, $bundle_type, $field_name) = explode(':', $plugin['name']);
@@ -128,18 +132,77 @@ function ctools_entity_field_value_ctools_access_settings_submit($form, &$form_s
   $instance  = $instances[$field_name];
   $field     = field_info_field_by_id($instance['field_id']);
   foreach ($field['columns'] as $column => $attributes) {
-    $columns[] = _field_sql_storage_columnname($field_name, $column);
+    $columns[$column] = _field_sql_storage_columnname($field_name, $column);
+  }
+  $items = _ctools_entity_field_value_get_proper_form_items($field, $form_state['values']['settings'][$field_name][$langcode], array_keys($columns));
+  foreach ($columns as $column => $sql_column) {
+    $column_items = _ctools_entity_field_value_filter_items_by_column($items, $column);
+    $form_state['values']['settings'][$sql_column] = $column_items;
   }
+  $form_state['values']['settings'][$field_name][$langcode] = $items;
+}
+
+function _ctools_entity_field_value_get_proper_form_items($field, $form_items, $columns) {
+  $items = array();
+
+  if (!is_array($form_items)) { // Single value item.
+    foreach ($columns as $column) {
+      $items[0][$column] = $form_items;
+    }
+    return $items;
+  }
+
+  foreach ($form_items as $delta => $value) {
+    $item = array();
+    if (is_numeric($delta)) { // Array of field values.
+      if (!is_array($value)) {  // Single value in array.
+        foreach ($columns as $column) {
+          $item[$column] = $value;
+        }
+      }
+      else { // Value has colums.
+        foreach ($columns as $column) {
+          $item[$column] = isset($value[$column]) ? $value[$column] : '';
+        }
+      }
+    }
+    $items[] = $item;
+  }
+
+  // Check if $form_items is an array of columns.
+  $item = array();
+  $has_columns = FALSE;
   foreach ($columns as $column) {
-    $form_state['values']['settings'][$column] = $form_state['input']['settings'][$field_name][$langcode];
+    if (isset($form_items[$column])) {
+      $has_columns = TRUE;
+      $item[$column] =  $form_items[$column];
+    }
+    else {
+      $item[$column] = '';
+    }
+  }
+  if ($has_columns) {
+    $items[] = $item;
+  }
+
+  // Remove empty values.
+  $items = _field_filter_items($field, $items);
+  return $items;
+}
+
+function _ctools_entity_field_value_filter_items_by_column($items, $column) {
+  $column_items = array();
+  foreach ($items as $delta => $values) {
+    $column_items[$delta] = isset($values[$column]) ? $values[$column] : '';
   }
+  return $column_items;
 }
 
 /**
  * Check for access.
  */
 function ctools_entity_field_value_ctools_access_check($conf, $context, $plugin) {
-  if (!isset($context->data)) {
+  if ((!is_object($context)) || (empty($context->data))) {
     // If the context doesn't exist -- for example, a newly added entity
     // reference is used as a pane visibility criteria -- we deny access.
     return FALSE;
@@ -166,16 +229,27 @@ function ctools_entity_field_value_ctools_access_check($conf, $context, $plugin)
 
       // Check field value.
       foreach ($field_items as $field_value) {
-        foreach ($field_value as $field_column => $value) {
-          // Iterate through config values.
-          foreach ($conf_value_array as $conf_value) {
+        // Iterate through config values.
+        foreach ($conf_value_array as $conf_value) {
+          $match = FALSE;
+          foreach ($field_value as $field_column => $value) {
             // Check access only for stored in config column values.
-            if (isset($conf_value[$field_column]) && $value == $conf_value[$field_column]) {
-              return TRUE;
+            if (isset($conf_value[$field_column])) {
+              if ($value == $conf_value[$field_column]) {
+                $match = TRUE;
+              }
+              else {
+                $match = FALSE;
+                break;
+              }
             }
           }
+          if ($match) {
+            return TRUE;
+          }
         }
       }
+      return FALSE;
     }
   }
 
@@ -184,7 +258,7 @@ function ctools_entity_field_value_ctools_access_check($conf, $context, $plugin)
 
 function _ctools_entity_field_value_ctools_access_get_conf_field_values($values, $langcode = LANGUAGE_NONE) {
   if (!is_array($values) || !isset($values[$langcode])) {
-    return;
+    return NULL;
   }
   $conf_values = array();
 
@@ -207,41 +281,130 @@ function ctools_entity_field_value_ctools_access_summary($conf, $context, $plugi
   $entity      = (object)array(
     $entity_info['entity keys']['bundle'] => $bundle_type,
   );
-  $string = '';
   $keys   = array();
-  $values = array();
+  $value_keys = array();
+  $keyed_elements = array();
   foreach ($field['columns'] as $column => $attributes) {
     $conf_key = _field_sql_storage_columnname($field_name, $column);
-    if (count($field['columns']) > 1) {
-      // Add some sort of handling for compound fields
-    }
-    else {
-      if (isset($conf[$conf_key])) {
-        $entity->{$field_name}[LANGUAGE_NONE][] = array($column => $conf[$conf_key]);
+    $keyed_elements["@{$column}_value"] = array();
+
+    if (isset($conf[$conf_key])) {
+      if (is_array($conf[$conf_key])) {
+        $i = 0;
+        foreach ($conf[$conf_key] as $conf_value) {
+          if (!is_array($conf_value)) {
+            $entity->{$field_name}[LANGUAGE_NONE][$i][$column] = $conf_value;
+            $keyed_elements["@{$column}_value"][$i] = array('#markup' => $conf_value);
+          }
+          elseif (isset($conf_value[$column])) {
+            $entity->{$field_name}[LANGUAGE_NONE][$i][$column] = $conf_value[$column];
+            $keyed_elements["@{$column}_value"][$i] = array('#markup' => $conf_value[$column]);
+          }
+          $i++;
+        }
+      }
+      else {
+        $entity->{$field_name}[LANGUAGE_NONE][0][$column] = $conf[$conf_key];
+        $keyed_elements["@{$column}_value"][0] = array('#markup' => $conf[$conf_key]);
       }
     }
-    $string .= " @{$column} equals @{$column}_value";
+
     $keys['@' . $column] = $column;
-    $values["@{$column}_value"] = $conf[$conf_key];
+    $value_keys[] = "@{$column}_value";
   }
+  $elements = array();
+  $items = isset($entity->{$field_name}[LANGUAGE_NONE]) ? $entity->{$field_name}[LANGUAGE_NONE] : array();
   $view_mode = 'full';
-  $null      = NULL;
-  $options   = array('language' => LANGUAGE_NONE);
   ctools_include('fields');
-  $display         = field_get_display($instance, $view_mode, $entity);
+  $display = field_get_display($instance, $view_mode, $entity);
+  if (!isset($display['module'])) {
+    $display['module'] = $field['module'];
+  }
   if (isset($display['module'])) {
-    $display['type'] = 'list_default';
-    $function        = $display['module'] . '_field_formatter_view';
-    $items           = isset($entity->{$field_name}[LANGUAGE_NONE]) ? $entity->{$field_name}[LANGUAGE_NONE] : array();
+    // Choose simple formatter for well known cases.
+    switch ($display['module']) {
+      case 'text':
+        $display['type'] = 'text_default';
+        break;
+
+      case 'list':
+        $display['type'] = 'list_default';
+        if ($field['type'] == 'list_boolean') {
+          $allowed_values = list_allowed_values($field, $instance, $entity_type, $entity);
+          foreach ($items as $item) {
+            if (isset($allowed_values[$item['value']])) {
+              if ($allowed_values[$item['value']] == '') {
+                $display['type'] = 'list_key';
+                break;
+              }
+            }
+            else {
+              $display['type'] = 'list_key';
+            }
+          }
+        }
+        break;
+
+      case 'taxonomy':
+        $display['type'] = 'taxonomy_term_reference_plain';
+        break;
+
+      case 'entityreference':
+        $display['type'] = 'entityreference_label';
+        break;
+
+      default :
+        // Use field instance formatter setting.
+        break;
+    }
+
+    $function = $display['module'] . '_field_formatter_view';
     if (function_exists($function)) {
-      $elements = $function($entity_type, $entity, $field, $instance, LANGUAGE_NONE, $items, $display);
+      $entity_group = array(0 => $entity);
+      $item_group = array(0 => $items);
+      $instance_group = array(0 => $instance);
+      field_default_prepare_view($entity_type, $entity_group, $field, $instance_group, LANGUAGE_NONE, $item_group, $display);
+      $elements = $function($entity_type, $entity, $field, $instance, LANGUAGE_NONE, $item_group[0], $display);
     }
-    $value_keys = array_keys($values);
-    foreach ($value_keys as $key => $value) {
-      $values[$value] = isset($elements[$key]['#markup']) ? $elements[$key]['#markup'] : '';
+  }
+  if (count($elements) > 0) {
+    foreach ($field['columns'] as $column => $attributes) {
+      if (count($field['columns']) == 1) {
+        $keyed_elements["@{$column}_value"] = $elements;
+      }
     }
   }
-  $values = array_merge($keys, $values);
-  return t($string, $values);
+  $values = array();
+  foreach ($value_keys as $key) {
+    $output = array();
+    $elements = $keyed_elements[$key];
+    if (is_array($elements)) {
+      foreach ($elements as $element_key => $element) {
+        if (is_numeric($element_key)) {
+          $value_str= strip_tags(drupal_render($element));
+          if (strlen($value_str) > 0) {
+            $output[] = $value_str;
+          }
+        }
+      }
+    }
+    else {
+      $value_str = strip_tags(drupal_render($elements));
+      if (strlen($value_str) > 0) {
+        $output[] = $value_str;
+      }
+    }
+    $value = implode(', ', $output);
+    if ($value !== '') {
+      $values[$key] = implode(', ', $output);
+    }
+  }
+  $string = '';
+  $value_count = count($values);
+  foreach ($keys as $key_name => $column) {
+    if (isset($values[$key_name . '_value'])) {
+      $string .= ($value_count > 1) ? " @{$column} = @{$column}_value" : "@{$column}_value";
+    }
+  }
+  return t('@field is set to "!value"', array('@field' => $instance['label'], '!value' => format_string($string, array_merge($keys, $values))));
 }
-
diff --git a/drupal7/sites/all/modules/ctools/plugins/access/node_comment.inc b/drupal7/sites/all/modules/ctools/plugins/access/node_comment.inc
new file mode 100644
index 00000000..915ee20e
--- /dev/null
+++ b/drupal7/sites/all/modules/ctools/plugins/access/node_comment.inc
@@ -0,0 +1,31 @@
+<?php
+/**
+ * @file
+ * Plugin to provide access control based upon node comment status.
+ */
+
+/**
+ * Plugins are described by creating a $plugin array which will be used
+ * by the system that includes this file.
+ */
+$plugin = array(
+  'title' => t("Node: comments are open"),
+  'description' => t('Control access by the nodes comment status.'),
+  'callback' => 'ctools_node_comment_ctools_access_check',
+  'summary' => 'ctools_node_comment_ctools_access_summary',
+  'required context' => new ctools_context_required(t('Node'), 'node'),
+);
+
+/**
+ * Checks for access.
+ */
+function ctools_node_comment_ctools_access_check($conf, $context) {
+  return (!empty($context->data) && $context->data->comment == 2);
+}
+
+/**
+ * Provides a summary description based upon the checked node_status.
+ */
+function ctools_node_comment_ctools_access_summary($conf, $context) {
+  return t('Returns true if the nodes comment status is "open".');
+}
diff --git a/drupal7/sites/all/modules/ctools/plugins/access/string_length.inc b/drupal7/sites/all/modules/ctools/plugins/access/string_length.inc
index 2bad6afb..91abf227 100644
--- a/drupal7/sites/all/modules/ctools/plugins/access/string_length.inc
+++ b/drupal7/sites/all/modules/ctools/plugins/access/string_length.inc
@@ -59,7 +59,7 @@ function ctools_string_length_ctools_access_check($conf, $context) {
       return $length < $conf['length'];
     case '<=':
       return $length <= $conf['length'];
-    case '==':
+    case '=':
       return $length == $conf['length'];
     case '!=':
       return $length != $conf['length'];
@@ -68,6 +68,8 @@ function ctools_string_length_ctools_access_check($conf, $context) {
     case '>=':
       return $length >= $conf['length'];
   }
+  // Invalid Operator sent, return FALSE.
+  return FALSE;
 }
 
 /**
diff --git a/drupal7/sites/all/modules/ctools/plugins/arguments/entity_id.inc b/drupal7/sites/all/modules/ctools/plugins/arguments/entity_id.inc
index 451d444c..214dc55f 100644
--- a/drupal7/sites/all/modules/ctools/plugins/arguments/entity_id.inc
+++ b/drupal7/sites/all/modules/ctools/plugins/arguments/entity_id.inc
@@ -16,6 +16,10 @@ $plugin = array(
   'context' => 'ctools_argument_entity_id_context',
   'get child' => 'ctools_argument_entity_id_get_child',
   'get children' => 'ctools_argument_entity_id_get_children',
+  'default' => array(
+    'entity_id' => ''
+  ),
+  'placeholder form' => 'ctools_argument_entity_id_ctools_argument_placeholder',
 );
 
 function ctools_argument_entity_id_get_child($plugin, $parent, $child) {
@@ -57,6 +61,18 @@ function ctools_argument_entity_id_context($arg = NULL, $conf = NULL, $empty = F
   }
 
   if (!is_numeric($arg)) {
+    $preg_matches = array();
+    $match        = preg_match('/\[id: (\d+)\]/', $arg, $preg_matches);
+    if (!$match) {
+      $match = preg_match('/^id: (\d+)/', $arg, $preg_matches);
+    }
+
+    if ($match) {
+      $id = $preg_matches[1];
+    }
+    if (is_numeric($id)) {
+      return ctools_context_create('entity:' . $entity_type, $id);
+    }
     return FALSE;
   }
 
@@ -68,3 +84,59 @@ function ctools_argument_entity_id_context($arg = NULL, $conf = NULL, $empty = F
   return ctools_context_create('entity:' . $entity_type, $entity[$arg]);
 }
 
+function ctools_argument_entity_id_settings_form(&$form, &$form_state, $conf) {
+  $plugin = &$form_state['plugin'];
+
+  $form['settings']['entity'] = array(
+    '#title' => t('Enter the title or ID of a @entity entity', array('@entity' => $plugin['keyword'])),
+    '#type' => 'textfield',
+    '#maxlength' => 512,
+    '#autocomplete_path' => 'ctools/autocomplete/' . $plugin['keyword'],
+    '#weight' => -10,
+  );
+
+  if (!empty($conf['entity_id'])) {
+    $info = entity_load($plugin['keyword'], array($conf['entity_id']));
+    $info = $info[$conf['entity_id']];
+    if ($info) {
+      $entity = entity_get_info($plugin['keyword']);
+      $uri = entity_uri($plugin['keyword'], $info);
+      if (is_array($uri) && $entity['entity keys']['label']) {
+        $link = l(t("'%title' [%type id %id]", array('%title' => $info->{$entity['entity keys']['label']}, '%type' => $plugin['keyword'], '%id' => $conf['entity_id'])), $uri['path'], array('attributes' => array('target' => '_blank', 'title' => t('Open in new window')), 'html' => TRUE));
+      }
+      elseif (is_array($uri)) {
+        $link = l(t("[%type id %id]", array('%type' => $plugin['keyword'], '%id' => $conf['entity_id'])), $uri['path'], array('attributes' => array('target' => '_blank', 'title' => t('Open in new window')), 'html' => TRUE));
+      }
+      elseif ($entity['entity keys']['label']) {
+        $link = l(t("'%title' [%type id %id]", array('%title' => $info->{$entity['entity keys']['label']}, '%type' => $plugin['keyword'], '%id' => $conf['entity_id'])), file_create_url($uri), array('attributes' => array('target' => '_blank', 'title' => t('Open in new window')), 'html' => TRUE));
+      }
+      else {
+        $link = t("[%type id %id]", array('%type' => $plugin['keyword'], '%id' => $conf['entity_id']));
+      }
+      $form['settings']['entity']['#description'] = t('Currently set to !link', array('!link' => $link));
+    }
+  }
+
+  $form['settings']['entity_id'] = array(
+    '#type' => 'value',
+    '#value' => $conf['entity_id'],
+  );
+
+  $form['settings']['entity_type'] = array(
+    '#type' => 'value',
+    '#value' => $plugin['keyword'],
+  );
+
+  return $form;
+}
+
+function ctools_argument_entity_id_ctools_argument_placeholder($conf) {
+  $conf = array(
+    '#title'             => t('Enter the title or ID of a @entity entity', array('@entity' => $conf['keyword'])),
+    '#type'              => 'textfield',
+    '#maxlength'         => 512,
+    '#autocomplete_path' => 'ctools/autocomplete/' . $conf['keyword'],
+    '#weight'            => -10,
+  );
+  return $conf;
+}
diff --git a/drupal7/sites/all/modules/ctools/plugins/content_types/block/block.inc b/drupal7/sites/all/modules/ctools/plugins/content_types/block/block.inc
index 7c551b9a..4d4c31c3 100644
--- a/drupal7/sites/all/modules/ctools/plugins/content_types/block/block.inc
+++ b/drupal7/sites/all/modules/ctools/plugins/content_types/block/block.inc
@@ -148,16 +148,19 @@ function ctools_block_content_type_render($subtype, $conf) {
   $block = module_invoke($module, 'block_view', $delta);
 
   if (!empty($info)) {
+    // Valid PHP function names cannot contain hyphens.
+    $block_delta = str_replace('-', '_', $delta);
+
     // Allow modules to modify the block before it is viewed, via either
     // hook_block_view_alter() or hook_block_view_MODULE_DELTA_alter().
-    drupal_alter(array('block_view', "block_view_{$module}_{$delta}"), $block, $info);
+    drupal_alter(array('block_view', "block_view_{$module}_{$block_delta}"), $block, $info);
   }
-  $block = (object) $block;
 
   if (empty($block)) {
     return;
   }
 
+  $block = (object) $block;
   $block->module = $module;
   $block->delta = $delta;
 
diff --git a/drupal7/sites/all/modules/ctools/plugins/content_types/comment/comment_links.inc b/drupal7/sites/all/modules/ctools/plugins/content_types/comment/comment_links.inc
new file mode 100644
index 00000000..c8fefcca
--- /dev/null
+++ b/drupal7/sites/all/modules/ctools/plugins/content_types/comment/comment_links.inc
@@ -0,0 +1,80 @@
+<?php
+
+/**
+ * Plugins are described by creating a $plugin array which will be used
+ * by the system that includes this file.
+ */
+$plugin = array(
+  'single' => TRUE,
+  'title' => t('Comment links'),
+  'icon' => 'icon_comment.png',
+  'description' => t('Comment links of the referenced comment.'),
+  'required context' => new ctools_context_required(t('Comment'), 'entity:comment'),
+  'category' => t('Comment'),
+  'defaults' => array(
+    'override_title' => FALSE,
+    'override_title_text' => '',
+    'build_mode' => '',
+  ),
+);
+
+/**
+ * Output function for the comment links.
+ */
+function ctools_comment_links_content_type_render($subtype, $conf, $panel_args, $context) {
+  if (!empty($context) && empty($context->data)) {
+    return;
+  }
+
+  $comment = isset($context->data) ? clone($context->data) : NULL;
+  $block = new stdClass();
+  $block->module = 'comment';
+  $block->delta  = $comment->cid;
+
+  if (empty($comment)) {
+    $block->delta   = 'placeholder';
+    $block->subject = t('Comment subject.');
+    $block->content = t('Comment links go here.');
+  }
+  else {
+    $node = node_load($comment->nid);
+    $block->subject = $comment->subject;
+    comment_build_content($comment, $node, $conf['build_mode']);
+    $block->content = $comment->content['links'];
+  }
+  return $block;
+}
+
+/**
+ * Returns an edit form for the custom type.
+ */
+function ctools_comment_links_content_type_edit_form($form, &$form_state) {
+  $conf = $form_state['conf'];
+
+  $entity = entity_get_info('comment');
+  $build_mode_options = array();
+  foreach ($entity['view modes'] as $mode => $option) {
+    $build_mode_options[$mode] = $option['label'];
+  }
+
+  $form['build_mode'] = array(
+    '#title' => t('Build mode'),
+    '#type' => 'select',
+    '#description' => t('Select a build mode for this comment.'),
+    '#options' => $build_mode_options,
+    '#default_value' => $conf['build_mode'],
+  );
+
+  return $form;
+}
+
+function ctools_comment_links_content_type_edit_form_submit($form, &$form_state) {
+  // Copy everything from our defaults.
+  foreach (array_keys($form_state['plugin']['defaults']) as $key) {
+    $form_state['conf'][$key] = $form_state['values'][$key];
+  }
+}
+
+function ctools_comment_links_content_type_admin_title($subtype, $conf, $context) {
+  return t('"@s" links', array('@s' => $context->identifier));
+}
diff --git a/drupal7/sites/all/modules/ctools/plugins/content_types/entity_context/entity_field.inc b/drupal7/sites/all/modules/ctools/plugins/content_types/entity_context/entity_field.inc
index d7d6319c..5861d1c5 100644
--- a/drupal7/sites/all/modules/ctools/plugins/content_types/entity_context/entity_field.inc
+++ b/drupal7/sites/all/modules/ctools/plugins/content_types/entity_context/entity_field.inc
@@ -118,6 +118,8 @@ function ctools_entity_field_content_type_render($subtype, $conf, $panel_args, $
   $field_settings = array(
     'label' => $label,
     'type' => $conf['formatter'],
+    // Pass all entity field panes settings to field display settings.
+    'pane_settings' => $conf,
   );
 
   // Get the field output, and the title.
@@ -127,33 +129,19 @@ function ctools_entity_field_content_type_render($subtype, $conf, $panel_args, $
 
   $all_values = field_get_items($entity_type, $entity, $field_name, $language);
   if (!is_array($all_values)) {
-    $all_values = array();
+    // Do not render if the field is empty.
+    return;
   }
 
   // Reverse values.
   if (isset($conf['delta_reversed']) && $conf['delta_reversed']) {
-    $all_values = array_reverse($all_values);
+    $all_values = array_reverse($all_values, TRUE);
   }
 
   if (isset($conf['delta_limit'])) {
-    $delta_limit = $conf['delta_limit'];
     $offset = intval($conf['delta_offset']);
-    $total = count($all_values);
-
-    if ($delta_limit == 0) {
-      $delta_limit = $total - $offset;
-    }
-
-    $new_values = array();
-    for ($i = 0; $i < $delta_limit; $i++) {
-      $new_delta = $offset + $i;
-
-      if (isset($all_values[$new_delta])) {
-        $new_values[] = $all_values[$new_delta];
-      }
-    }
-
-    $all_values = $new_values;
+    $limit = !empty($conf['delta_limit']) ? $conf['delta_limit'] : NULL;
+    $all_values = array_slice($all_values, $offset, $limit, TRUE);
   }
 
   $clone = clone $entity;
@@ -263,10 +251,21 @@ function ctools_entity_field_content_type_formatter_styles_submit($form, &$form_
 }
 
 /**
-* Returns the administrative title for a type.
-*/
+ * Returns the administrative title for a type.
+ */
 function ctools_entity_field_content_type_admin_title($subtype, $conf, $context) {
   list($bundle, $field_name) = explode(':', $subtype);
   ctools_include('fields');
-  return t('"@s" @field', array('@s' => $context->identifier, '@field' => ctools_field_label($field_name)));
+  if (is_object($context) && isset($context->identifier)) {
+    $identifier = $context->identifier;
+  }
+  else {
+    $type = 'ctools_entity_field_content_type_admin_title';
+    $message = t('Context is missing for field: @name', array('@name' => $subtype));
+    $variables = array($subtype, $conf, $context);
+    watchdog($type, $message, $variables, $severity = WATCHDOG_NOTICE);
+    $identifier = t('Unknown');
+  }
+
+  return t('"@s" @field', array('@s' => $identifier, '@field' => ctools_field_label($field_name)));
 }
diff --git a/drupal7/sites/all/modules/ctools/plugins/content_types/node/node.inc b/drupal7/sites/all/modules/ctools/plugins/content_types/node/node.inc
index 30e06f04..7e77194c 100644
--- a/drupal7/sites/all/modules/ctools/plugins/content_types/node/node.inc
+++ b/drupal7/sites/all/modules/ctools/plugins/content_types/node/node.inc
@@ -11,7 +11,7 @@
  * by the system that includes this file.
  */
 $plugin = array(
-  'title' => t('Node'),
+  'title' => t('Existing node'),
   'single' => TRUE,
   'defaults' => array(
     'nid' => '',
@@ -20,7 +20,6 @@ $plugin = array(
     'identifier' => '',
     'build_mode' => 'teaser',
   ),
-  'title' => t('Existing node'),
   'icon' => 'icon_node.png',
   'description' => t('Add a node from your site as content.'),
   'category' => t('Custom'),
diff --git a/drupal7/sites/all/modules/ctools/plugins/content_types/node_context/node_comment_wrapper.inc b/drupal7/sites/all/modules/ctools/plugins/content_types/node_context/node_comment_wrapper.inc
new file mode 100644
index 00000000..8e25429f
--- /dev/null
+++ b/drupal7/sites/all/modules/ctools/plugins/content_types/node_context/node_comment_wrapper.inc
@@ -0,0 +1,117 @@
+<?php
+
+if (module_exists('comment')) {
+  /**
+   * Plugins are described by creating a $plugin array which will be used
+   * by the system that includes this file.
+   */
+  $plugin = array(
+    'single' => TRUE,
+    'title' => t('Comments and comment form.'),
+    'icon' => 'icon_node.png',
+    'description' => t('The comments and comment form for the referenced node.'),
+    'required context' => new ctools_context_required(t('Node'), 'node'),
+    'category' => t('Node'),
+    'defaults' => array(
+      'mode' => variable_get('comment_default_mode', COMMENT_MODE_THREADED),
+      'comments_per_page' => variable_get('comment_default_per_page', '50'),
+    ),
+  );
+}
+
+/**
+ * Render the node comments.
+ */
+function ctools_node_comment_wrapper_content_type_render($subtype, $conf, $panel_args, $context) {
+  $node = isset($context->data) ? clone($context->data) : NULL;
+  $block = new stdClass();
+  $block->module = 'comments';
+  $block->delta  = $node->nid;
+
+  $renderable = array(
+    '#theme' => 'comment_wrapper__node_' . $node->type,
+    '#node' => $node,
+    'comments' => array(),
+    'comment_form' => array(),
+  );
+
+  // Add in the comments.
+  if (($node->comment_count && user_access('access comments')) || user_access('administer comments')) {
+    $mode = variable_get('comment_default_mode_' . $node->type, COMMENT_MODE_THREADED);
+    $comments_per_page = variable_get('comment_default_per_page_' . $node->type, 50);
+    if ($cids = comment_get_thread($node, $mode, $comments_per_page)) {
+      $comments = comment_load_multiple($cids);
+      comment_prepare_thread($comments);
+      $build = comment_view_multiple($comments, $node);
+      $build['pager']['#theme'] = 'pager';
+      $renderable['comments'] = $build;
+    }
+  }
+
+  // Stuff in the comment form.
+  if ($node->comment == COMMENT_NODE_OPEN) {
+    if (user_access('post comments')) {
+      $comment = new stdClass();
+      $comment->nid = $node->nid;
+      $comment->pid = NULL;
+      $form_state = array(
+        'ctools comment alter' => TRUE,
+        'node' => $node,
+        'build_info' => array(
+          'args' => array(
+            $comment,
+          ),
+        ),
+      );
+      $renderable['comment_form'] = drupal_build_form('comment_node_' . $node->type . '_form', $form_state);
+    }
+    else if (!empty($conf['anon_links'])) {
+      $renderable['comment_form'] = theme('comment_post_forbidden', array('node' => $node));
+    }
+  }
+
+  $block->content = drupal_render($renderable);
+
+  return $block;
+}
+
+/**
+ * Returns an edit form for the comment wrapper.
+ */ 
+function ctools_node_comment_wrapper_content_type_edit_form($form, &$form_state) {
+  $conf = $form_state['conf'];
+  $form['mode'] = array(
+    '#type' => 'select',
+    '#title' => t('Mode'),
+    '#default_value' => $conf['mode'],
+    '#options' => _comment_get_modes(),
+    '#weight' => 1,
+  );
+  foreach (_comment_per_page() as $i) {
+    $options[$i] = t('!a comments per page', array('!a' => $i));
+  }
+  $form['comments_per_page'] = array('#type' => 'select',
+    '#title' => t('Pager'),
+    '#default_value' => $conf['comments_per_page'],
+    '#options' => $options,
+    '#weight' => 3,
+  );
+  return $form;
+}
+
+/**
+ * Submit handler for the comment wrapper settings form.
+ */
+function ctools_node_comment_wrapper_content_type_edit_form_submit($form, &$form_state) {
+  // Copy everything from our defaults.
+  foreach (array_keys($form_state['plugin']['defaults']) as $key) {
+    $form_state['conf'][$key] = $form_state['values'][$key];
+  }
+}
+
+/**
+ * Returns the administrative title.
+ */
+function ctools_node_comment_wrapper_content_type_admin_title($subtype, $conf, $context) {
+  return t('Comments and comment form');
+}
